/* qsk2d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;

/* Subroutine */ int qsk2d_c(D_fp fun, doublereal *a, doublereal *b,
        doublereal *abserr, doublereal *relerr, doublereal *result, 
        doublereal *errest, integer *nofun, doublereal *flag__)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2;

    /* Builtin functions */
    integer pow_ii(integer *, integer *);

    /* Local variables */
    static doublereal area, cor11, temp, step, qnow, f[16];
    static integer i__, j;
    static doublereal x[16], qdiff, fsave[240]  /* was [8][30] */;
    static integer nofin;
    static doublereal qleft;
    static integer nomax;
    static doublereal xsave[240]        /* was [8][30] */, f0, stone, qprev, 
            w0, w1, w2, w3, w4, x0;
    static integer levmin, levmax;
    static doublereal qright[31], esterr, tolerr;
    static integer levout, nim, lev;

#define fsave_ref(a_1,a_2) fsave[(a_2)*8 + a_1 - 9]
#define xsave_ref(a_1,a_2) xsave[(a_2)*8 + a_1 - 9]

/*   ESTIMATE THE INTEGRAL OF FUN(X) FROM A TO B */
/*   TO A USER PROVIDED TOLERANCE. */
/*   AN AUTOMATIC ADAPTIVE ROUTINE BASED ON */
/*   THE 8-PANEL NEWTON-COTES RULE. */

/*   INPUT .. */

/*   FUN     THE NAME OF THE INTEGRAND FUNCTION SUBPROGRAM FUN(X). */
/*   A       THE LOWER LIMIT OF INTEGRATION. */
/*   B       THE UPPER LIMIT OF INTEGRATION.(B MAY BE LESS THAN A.) */
/*   RELERR  A RELATIVE ERROR TOLERANCE. (SHOULD BE NON-NEGATIVE) */
/*   ABSERR  AN ABSOLUTE ERROR TOLERANCE. (SHOULD BE NON-NEGATIVE) */

/*   OUTPUT .. */

/*   RESULT  AN APPROXIMATION TO THE INTEGRAL HOPEFULLY SATISFYING THE */
/*           LEAST STRINGENT OF THE TWO ERROR TOLERANCES. */
/*   ERREST  AN ESTIMATE OF THE MAGNITUDE OF THE ACTUAL ERROR. */
/*   NOFUN   THE NUMBER OF FUNCTION VALUES USED IN CALCULATION OF RESULT. */
/*   FLAG    A RELIABILITY INDICATOR.  IF FLAG IS ZERO, THEN RESULT */
/*           PROBABLY SATISFIES THE ERROR TOLERANCE.  IF FLAG IS */
/*           XXX.YYY , THEN  XXX = THE NUMBER OF INTERVALS WHICH HAVE */
/*           NOT CONVERGED AND  .YYY = THE FRACTION OF THE INTERVAL */
/*           LEFT TO DO WHEN THE LIMIT ON  NOFUN  WAS APPROACHED. */

/*   ***   STAGE 1 ***   GENERAL INITIALIZATION */
/*   SET CONSTANTS. */

    levmin = 1;
    levmax = 30;
    levout = 6;
    nomax = 5000;
    i__1 = levout + 1;
    nofin = nomax - (levmax - levout + pow_ii(&c__2, &i__1) << 3);

/*   TROUBLE WHEN NOFUN REACHES NOFIN */

    w0 = .27908289241622575;
    w1 = 1.6615167548500882;
    w2 = -.26186948853615521;
    w3 = 2.9618342151675483;
    w4 = -1.2811287477954145;

/*   INITIALIZE RUNNING SUMS TO ZERO. */

    *flag__ = 0.;
    *result = 0.;
    cor11 = 0.;
    *errest = 0.;
    area = 0.;
    *nofun = 0;
    if (*a == *b) {
        goto L15;
    }

/*   ***   STAGE 2 ***   INITIALIZATION FOR FIRST INTERVAL */

    lev = 0;
    nim = 1;
    x0 = *a;
    x[15] = *b;
    qprev = 0.;
    f0 = (*fun)(&x0);
    stone = (*b - *a) / 16.;
    x[7] = (x0 + x[15]) / 2.;
    x[3] = (x0 + x[7]) / 2.;
    x[11] = (x[7] + x[15]) / 2.;
    x[1] = (x0 + x[3]) / 2.;
    x[5] = (x[3] + x[7]) / 2.;
    x[9] = (x[7] + x[11]) / 2.;
    x[13] = (x[11] + x[15]) / 2.;
    for (j = 2; j <= 16; j += 2) {
        f[j - 1] = (*fun)(&x[j - 1]);
/* L1: */
    }
    *nofun = 9;

/*   ***   STAGE 3 ***   CENTRAL CALCULATION */
/*   REQUIRES QPREV,X,X2,X4,...,X16,F,F2,F4,...,F16. */
/*   CALCULATES X1,X3,...X15, F1,F3,...F15,QLEFT,QRIGHT,QNOW,QDIFF,AREA. */

L2:
    x[0] = (x0 + x[1]) / 2.;
    f[0] = (*fun)(x);
    for (j = 3; j <= 15; j += 2) {
        x[j - 1] = (x[j - 2] + x[j]) / 2.;
        f[j - 1] = (*fun)(&x[j - 1]);
/* L3: */
    }
    *nofun += 8;
    step = (x[15] - x0) / 16.;
    qleft = (w0 * (f0 + f[7]) + w1 * (f[0] + f[6]) + w2 * (f[1] + f[5]) + w3 *
             (f[2] + f[4]) + w4 * f[3]) * step;
    qright[lev] = (w0 * (f[7] + f[15]) + w1 * (f[8] + f[14]) + w2 *
            (f[9] + f[13]) + w3 * (f[10] + f[12]) + w4 * f[11]) * step;
    qnow = qleft + qright[lev];
    qdiff = qnow - qprev;
    area += qdiff;

/*   ***   STAGE 4 *** INTERVAL CONVERGENCE TEST */

    esterr = abs(qdiff) / 1023.;
/* Computing MAX */
    d__1 = *abserr, d__2 = *relerr * abs(area);
    tolerr = max(d__1,d__2) * (step / stone);
    if (lev < levmin) {
        goto L4;
    }
    if (lev >= levmax) {
        goto L8;
    }
    if (*nofun > nofin) {
        goto L7;
    }
    if (esterr <= tolerr) {
        goto L9;
    }

/*   ***   STAGE 5   ***   NO CONVERGENCE */
/*   LOCATE NEXT INTERVAL. */

L4:
    nim <<= 1;
    ++lev;

/*   STORE RIGHT HAND ELEMENTS FOR FUTURE USE. */

    for (i__ = 1; i__ <= 8; ++i__) {
        fsave_ref(i__, lev) = f[i__ + 7];
        xsave_ref(i__, lev) = x[i__ + 7];
/* L5: */
    }

/*   ASSEMBLE LEFT HAND ELEMENTS FOR IMMEDIATE USE. */

    qprev = qleft;
    for (i__ = 1; i__ <= 8; ++i__) {
        j = -i__;
        f[(j << 1) + 17] = f[j + 8];
        x[(j << 1) + 17] = x[j + 8];
/* L6: */
    }
    goto L2;

/*   ***   STAGE 6   ***   TROUBLE SECTION */
/*   NUMBER OF FUNCTION VALUES IS ABOUT TO EXCEED LIMIT. */

L7:
    nofin <<= 1;
    levmax = levout;
    *flag__ += (*b - x0) / (*b - *a);
    goto L9;

/*   CURRENT LEVEL IS LEVMAX. */

L8:
    *flag__ += 1.;

/*   ***   STAGE 7   ***   INTERVAL CONVERGED */
/*   ADD CONTRIBUTIONS INTO RUNNING SUMS. */

L9:
    *result += qnow;
    *errest += esterr;
    cor11 += qdiff / 1023.;

/*   LOCATE NEXT INTERVAL. */

L10:
    if (nim == nim / 2 << 1) {
        goto L11;
    }
    nim /= 2;
    --lev;
    goto L10;
L11:
    ++nim;
    if (lev <= 0) {
        goto L13;
    }

/*   ASSEMBLE ELEMENTS REQUIRED FOR THE NEXT INTERVAL. */

    qprev = qright[lev - 1];
    x0 = x[15];
    f0 = f[15];
    for (i__ = 1; i__ <= 8; ++i__) {
        f[(i__ << 1) - 1] = fsave_ref(i__, lev);
        x[(i__ << 1) - 1] = xsave_ref(i__, lev);
/* L12: */
    }
    goto L2;

/*   ***   STAGE 8   ***   FINALIZE AND RETURN */

L13:
    *result += cor11;

/*   MAKE SURE ERREST NOT LESS THAN ROUNDOFF LEVEL. */

    if (*errest == 0.) {
        goto L15;
    }
L14:
    temp = abs(*result) + *errest;
    if (temp != abs(*result)) {
        goto L15;
    }
    *errest *= 2.;
    goto L14;
L15:
    return 0;
} /* qsk2d_c */

#undef xsave_ref
#undef fsave_ref
